#pragma once

/**
* @enum NAVERAPP_UPDATE_TYPE
* @brief Ʈ Ÿ  ̴.
*/
#include <atlstr.h>
#include <list>
#include <vector>

typedef std::basic_string<TCHAR> tstring;

struct AgreementUrlItem
{
	tstring url;
};

typedef std::vector<AgreementUrlItem> AgreementUrlList;

enum NAVERAPP_UPDATE_TYPE
{
	NUPDATE_TYPE_NORMAL = 0,
	NUPDATE_TYPE_SILENT = 0x01,
	NUPDATE_TYPE_NOEXTRAWORK = 0x02,
};

/**
* @enum NAVERAPP_UPDATE_STATUS
* @brief Ʈ ¸  ̴.
*/
enum NAVERAPP_UPDATE_STATUS
{
	NUPDATE_STATUS_SUCCESS = 0,
	NUPDATE_STATUS_CANCEL,
	NUPDATE_STATUS_ERROR,
	NUPDATE_STATUS_STILL_ACTIVE,
	NUPDATE_STATUS_ETC_ERROR = 1000,
};

/**
* @enum NAVERAPP_UNISTALLER_TYPE
* @brief ν緯ŸѰ̴.
*/
enum NAVERAPP_UNISTALLER_TYPE
{
	NUINSTALLER_TYPE_NSIS = 0,
	NUINSTALLER_TYPE_APP,
};

typedef int (*Func_Request)(const char *query, char *response, int response_length);

enum NAVERAPP_INSTALL_STATUS
{
	NotInstalled = 0,
	OldVersion,
	LatestVersion,
};

class AgentDLLWrapper
{
public:
	AgentDLLWrapper(const TCHAR *path);
	~AgentDLLWrapper();

	BOOL Close();

	BOOL	GetInstalledStatus(NAVERAPP_INSTALL_STATUS &status, int *error_code = NULL, CString *error_msg = NULL );
	BOOL	RunUpgrader(DWORD runType, int *error_code = NULL, CString *error_msg = NULL );
	BOOL	GetUpdateStatus(int &status, int *error_code = NULL, CString *error_msg = NULL );
	int		GetAgreementUrlList(AgreementUrlList &urlList, int *error_code = NULL, CString *error_msg = NULL );
	BOOL	IsAgreementShow( int *error_code = NULL, CString *error_msg = NULL );
	BOOL	AgreementShown(BOOL bShow, int *error_code = NULL, CString *error_msg = NULL );
	int		GetUninstallerInfo( TCHAR* path, int pathLen, TCHAR *param, int paramLen, int &uninstallerType, int *error_code = NULL, CString *error_msg = NULL );
	BOOL	GetGuid(TCHAR *guid, int guidSize, int *error_code = NULL, CString *error_msg = NULL );
	BOOL	GetInstallError(int *error_code = NULL, CString *error_msg = NULL );
	BOOL	GetUninstallError(int *error_code = NULL, CString *error_msg = NULL );

	Func_Request GetFuncRequest();
	
private:
	BOOL DefaultRequest( const TCHAR *queryid, const TCHAR *value, CString &data, int *error_code, CString *error_msg );
	BOOL Open( const TCHAR *filename );
	BOOL RequestInstallError(int *error_code, CString *error_msg);
	BOOL RequestUninstallError(int *error_code, CString *error_msg);
	BOOL RequestGuid(TCHAR *guid, int guidSize, int *error_code, CString *error_msg);
	BOOL RequestIsAgreementShow(int *error_code, CString *error_msg);
	BOOL RequestAgreementShown(BOOL bShow, int *error_code, CString *error_msg);
	BOOL RequestIsInstalled(int *error_code, CString *error_msg);
	BOOL RequestIsVersionChanged(int *error_code, CString *error_msg);
	BOOL RequestRunUpgrader(DWORD runType, int *error_code, CString *error_msg);
	BOOL RequestGetUpdateStatus(int &status, int *error_code, CString *error_msg);
	int  RequestGetUnistallerInfo(TCHAR* path, int pathLen, TCHAR *param, int paramLen, int &uninstallerType, int *error_code, CString *error_msg);
	int	 RequestAgreementUrlList(AgreementUrlList &urlList, int *error_code, CString *error_msg);
	BOOL SendRequest( const char *query, char *response, int responseSize );

private:
/*
	Func_IsInstalled		m_pfn_IsInstalled;
	Func_GetServiceID		m_pfn_GetServiceID;
	Func_RunUpgrader		m_pfn_RunUpgrader;
	Func_GetUpdateStatus	m_pfn_GetUpdateStatus;
	Func_GetUnistallerInfo	m_pfn_GetUnistallerInfo;
	Func_GetLocalVersion	m_pfn_GetLocalVersion;
	Func_GetRecentVersion	m_pfn_GetRecentVersion;
	Func_IsVersionChanged	m_pfn_IsVersionChanged;
	Func_RunService			m_pfn_RunService;
*/
	Func_Request			m_pfn_Request;
	HMODULE		m_module;

	BOOL					m_open;
	CString					m_dllpath;
};

class AgentDLLManager
{
public:
	static AgentDLLWrapper* Register( const TCHAR *guid, const TCHAR *url );
	static BOOL Unregister( AgentDLLWrapper *agentdll );

public:
	static AgentDLLWrapper* Find( const TCHAR *guid );

private:
	static BOOL CheckSameAgentDLLVersion( const TCHAR *guid, const TCHAR *dllversion );
	static BOOL CreateAgentDLL( const TCHAR *guid, const TCHAR *dllversion, const TCHAR *dllurl);
};